/**********************************************************/
/*  ܤη꡼󤻡С                            */
/*                                      ԡƣӲ    */
/**********************************************************/
#include <stdio.h>
#include <X11/xpm.h>
#include "screenhack.h"
#include "obono.xpm"
#define UNIT		256

char *progclass = "obonosaver";
XrmOptionDescRec options [] = {
  { "-delay",	".delay",	XrmoptionSepArg, 0 },
  { "-count",	".count",	XrmoptionSepArg, 0 },
  { 0, 0, 0, 0 }
};
char *defaults [] = {
  ".delay:		20000",
  ".count:		32",
  0
};

/*=====  С  =====*/
void screenhack(Display *display, Window win) {
  int			i,j,screen,result,Count,Delay,Width,Height,pc[UNIT];
  unsigned long FGcolor,BGcolor;
  double		px[UNIT],py[UNIT],vx[UNIT],vy[UNIT],vq[UNIT],dx,dy,dr;

  GC				win_gc;
  XWindowAttributes xgwa;
  XpmAttributes 	xpmattrs;
  static Pixmap		obnpix;

  /*-----  ɤ  -----*/
  screen  = DefaultScreen(display);
  BGcolor = BlackPixel(display,screen);
  FGcolor = WhitePixel(display,screen);
  win_gc = XCreateGC(display,win,0,0);
  XSetBackground(display,win_gc,BGcolor);
  XSetForeground(display,win_gc,FGcolor);
  XGetWindowAttributes (display,win,&xgwa);

  /*-----  xpmեɤ߹  -----*/
  xpmattrs.valuemask=0;
  result=XpmCreatePixmapFromData(display,win,obono_xpm,&obnpix,0,&xpmattrs);
  if (!obnpix||(result!=XpmSuccess&&result!=XpmColorError)) {
	fprintf(stderr,"%s: Can't load OBONO images.\n",progclass);
	exit(1);
  }
  
  /*-----  ѥ᡼  -----*/
  Width=xgwa.width+2;
  Height=xgwa.height+2;
  Count=get_integer_resource("count", "Count");
  Delay=get_integer_resource("delay", "Delay");
  if (Count<4) { Count=4; } if (Count>256) { Count=256; }
  for (i=0; i<Count; i++) {
	px[i]=random()/(double)0x7fffffff*Width;
	py[i]=random()/(double)0x7fffffff*Height;
	pc[i]=(Count-i)*(i>Count-4);
	vx[i]=vy[i]=0.0; vq[i]=random()/(double)0x1fffffff-2.0;
  }

  while (1) {
	/*-----  ׻    -----*/
	for (i=0; i<Count; i++) for (j=0; j<Count; j++) {
	  if (i!=j) {
		dx=px[j]-px[i]; dy=py[j]-py[i]; dr=dx*dx+dy*dy;
		if (dr>0.0) { vx[i]+=dx/dr*vq[i]; vy[i]+=dy/dr*vq[i]; }
	  }
	}
	XClearWindow(display,win);
	for (i=0; i<Count; i++) {
	  px[i]+=vx[i]; py[i]+=vy[i]; vq[i]-=0.03125;
	  if (px[i]<0.0) { px[i]=0.0; vx[i]=-vx[i]/2.0; vq[i]=4.0; }
	  if (py[i]<0.0) { py[i]=0.0; vy[i]=-vy[i]/2.0; vq[i]=4.0; }
	  if (px[i]>(double)Width)
		{ px[i]=(double)Width;	vx[i]=-vx[i]/2.0; vq[i]=4.0; }
	  if (py[i]>(double)Height)
		{ py[i]=(double)Height;	vy[i]=-vy[i]/2.0; vq[i]=4.0; }
	  XCopyArea(display,obnpix,win,win_gc,pc[i]*20,0,20,20,
				(int)(px[i]-8.0),(int)(py[i]-8.0));
	}

	/*-----  ٥  -----*/
	XFlush(display);
	XSync (display,False);
	screenhack_handle_events (display);
	usleep(Delay);
  }
}
